#ifndef _BODY_DESCRIBE_H_
#define _BODY_DESCRIBE_H_

#include "BODY.h"
#include "BODY_Handler.h"
#include "Describe_BODY.h"
#include "IGES_Parser.h"
#include "STL_Parser.h"
#include "Quaternion.h"
#include "NURBS_Func.h"
#include "UserFunc.h"
#include "StdAfx.h"

#define EXT_IGES	1						// gqʗp(IGES)
#define EXT_STL		2						// gqʗp(STL)
#define CIRCLE_DIV_NUM 100					// ~`掞̉~
#define MAXSELECT	20000					// ZNV̍őobt@TCY
#define TOLERANCE   20						// NURBSȖʂ̑ẽftHgl

// j[penum
enum Menu{
	M_Version,
	M_Draw_Body,
	M_Draw_Surf,
	M_UnSelect,
	M_View_Angle,
	M_UserFunc_Canncel
};

enum Sub_Menu_View{
	S_M_XView,
	S_M_YView,
	S_M_ZView
};

// IGES`NX`
class DESCRIBE			// BODY`֐W߂NXp
{
public:
	DESCRIBE();		// RXgN^
	~DESCRIBE();	// fXgN^
	int BODY_Describe_Main(int,char **);		// `main
	
// ֐
private:
	// OpenGLp`֐̐錾staticKv
	static void Keyboard(unsigned char key, int x, int y);	// L[{[hCxg
	static void Display(void);								// `Cxg
	static void Motion(int,int);							// }EXCxg
	static void Reshape(int,int);							// ĕ`Cxg
	static void Mouse(int,int,int,int);						// }EXCxg
	static void Menu(int);									// j[Cxg
	static void Sub_Menu_View(int);							// Tuj[i_؊jCxg
	static void Sub_Menu_User(int);							// Tuj[iUsero^֐jCxg
	static void DoSelect(int,int);							// ZNV̐ݒ
	static int  ObjSelect(GLuint [],int);					// IuWFNgI𔻕
	static void Init(char *progname);						// `揉
	static void Idle();										// `AChOԂł̏Cxg
	static void Special(int,int,int);						// L[Cxg
	static void glDrawBODY();								// IGESf[^̕`
	static void glDrawAxis(double,double);					// ̕`
	static void glDrawRubberband(double,double,double,double);	// o[oh̕`
	static void glDraw_Line();								// `
	static void Draw_NurbsSurface(BODY *);					// NURBSȐ`
	static void Draw_NurbsCurve(BODY *);					// NURBSȐ`
	static void glDraw_SurfLine();							// NURBSȖʂ̃p[^C`
	static void Draw_TrimSurfe(BODY *);						// gʂ̕`
	static int GenBodyList();								// bodyǂݍ݃Xgɓo^
	static int NewPath();									// SPath,CPath̃[ZNgꂽGeBeBmۂ
	static void AddEntSymbolToObj();						// OBJECT\̂ɉԖڂ̋ȐorȖʂ̏t
	static int DelPath();									// SPath,CPath̃[
	static void UpDateDisplayList(int);						// fBXvCXg̍XV
	static void ClickPicking(GLuint SelectBuf[],int hits);	// IuWFNg̃}EXsbLO(NbN)
	static void DragPicking(GLuint SelectBuf[],int hits);	// IuWFNg̃}EXsbLO(hbO)
	static int OpenFile();									// CADf[^ǂݍ
	static int CheckExtention(char *);						// ǂݍ܂ꂽf[^̊gq`FbN
	static void ReDrawUserFunc();							// UserFuncs̍ĕ`Ăяo
	static void SetNewObject(int,int,int);					// sbNꂽIuWFNgOBJECTXgɓo^
	static void SetModelScale();							// fXP[Zbg
	static void ClearSeldEntList();							// ZNVXgyOBJECT̏
	static void UserViewCanncel();							// UserFuncɂĕ`悳ꂽ摜
	static void SelectionCanncel();							// ZNVLZ
	static void VersionInfo();								// o[Wo


// ϐ
private:
	static BODY *glbody;			// ǂݍBODYXg̐擪|C^
	static BODY *Curr_body;			// BODYXgɂ钍ڒBODYIuWFNgw
	static int  ScreenHeight;		// ftHgXN[̍
	static int  ScreenWidth;		// ftHgXN[̕
	static int  StartX;				// hbOJnʒuX
	static int  StartY;				// hbOJnʒuY
	static int  OldPosX;			// EBhEĕ`撼OXW
	static int  OldPosY;			// EBhEĕ`撼OYW
	static int  CurrentX;			// hbÖʒuX
	static int  CurrentY;			// hbÖʒuY
	static int  SweepSelectFlag;	// XC[vZNVJnƂtO
	static int  Vp[4];				// r[|Cg
	static GLuint  SelectBuf[MAXSELECT];	// ZNgobt@
	static int  LBtnFlag;			// NbNƂtO
	static int  RBtnFlag;			// ENbNƂtO
	static int  MBtnFlag;			// NbNƂtO
	static int  ShiftKeyFlag;		// ShiftL[ƂtO
	static int  CtrlKeyFlag;		// CtrlL[ƂtO
	static int  AltKeyFlag;			// AltL[ƂtO
	static double Trl[3];			// sړ
	static double AxisScale;		// `̃XP[
	static double ModelScale;		// f̃XP[
	static double ModelScale1st;	// fXP[̏l
	static double IdentX;			// }EX̐ΈʒuXEBhEł̑ΈʒůZWX
	static double IdentY;			// }EX̐ΈʒuYEBhEł̑ΈʒůZWY
	static Quat StartQ;				// ENbNuԂ̉]pi[NH[^jI
	static Quat TargetQ;			// 肮Ăr̃NH[^jI
	static double RotMx[TMATELEMNUM];	// NH[^jIϊ}gbNX
	static int  DrawSurfFlagCount;	// Surface`tOj[Iꂽ𐔂JE^
	static int  DrawBODYFlagCount;	// BODY`tOj[Iꂽ𐔂JE^
	static int DrawUserFuncFlag;			// PDT`tO
	static OBJECT SelectedEntList[MAXSELECT];	// ZNVꂽGeBeB𒀎i[Ă
	static int PickCount;			// sbN񐔂JEg
	static int BodyCount;			// body̐JEg
	static int CPickCount;			// NURBSȐsbNꂽJEg
	static int SPickCount;			// NURBSȖʂsbNꂽJEg
	static int  DrawBODYFlag;			// BODY`tO
	static int  DrawSurfFlag;			// Surface`tO
	static int  DrawBODY1st;
	static int  ExecUserFuncFlag[USERFUNCNUMMAX];	// UserFunc`tO
	static int	 ReDrawBODYFlag;		// BODY`1ڂtO
	static double Tolerance;			// NURBS\鎞̖ʂ̑e



private:
	static BODY_Handler BH;			// BODYpCX^X
	static BODYList	BodyList;		// BODYXg̑pCX^X
	static OBJECTList SeldEntList;	// ZNVꂽGeBeB𒀎i[ĂXg
	static IGES_PARSER Parser;		// IGESp[T[pIuWFNg𐶐
	static QUATERNION QFunc;		// NH[^jINX̃IuWFNg𐶐
	static NURBS_Func NFunc;		// NURBS_FuncNX̃IuWFNg𐶐
	static USER User;				// [U[NX̃IuWFNg𐶐
};


#endif
